package com.gxwebsoft.shop.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.entity.DealerReferee;
import com.gxwebsoft.shop.entity.DealerUser;
import com.gxwebsoft.shop.service.DealerApplyService;
import com.gxwebsoft.shop.entity.DealerApply;
import com.gxwebsoft.shop.param.DealerApplyParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.DealerRefereeService;
import com.gxwebsoft.shop.service.DealerUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分销商申请记录表控制器
 *
 * @author 科技小王子
 * @since 2024-07-28 11:57:41
 */
@Api(tags = "分销商申请记录表管理")
@RestController
@RequestMapping("/api/shop/dealer-apply")
public class DealerApplyController extends BaseController {
    @Resource
    private DealerApplyService dealerApplyService;
    @Resource
    private DealerUserService dealerUserService;
    @Resource
    private DealerRefereeService dealerRefereeService;

    @ApiOperation("分页查询分销商申请记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<DealerApply>> page(DealerApplyParam param) {
        // 使用关联查询
        return success(dealerApplyService.pageRel(param));
    }

    @ApiOperation("查询全部分销商申请记录表")
    @GetMapping()
    public ApiResult<List<DealerApply>> list(DealerApplyParam param) {
        // 使用关联查询
        return success(dealerApplyService.listRel(param));
    }

    @ApiOperation("根据id查询分销商申请记录表")
    @GetMapping("/{id}")
    public ApiResult<DealerApply> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(dealerApplyService.getByIdRel(id));
    }

    @Transactional(rollbackFor = {Exception.class})
    @ApiOperation("添加分销商申请记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DealerApply dealerApply) {
      final Integer refereeId = dealerApply.getRefereeId();
      final DealerUser dealerUser = new DealerUser();
      // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          dealerApply.setUserId(loginUser.getUserId());
          dealerUser.setUserId(loginUser.getUserId());
          dealerUser.setMobile(loginUser.getPhone());
          dealerUser.setTenantId(loginUser.getTenantId());
        }
      final int count = dealerUserService.count(new LambdaQueryWrapper<DealerUser>().eq(DealerUser::getUserId, refereeId));
      System.out.println("count = " + count);
      if (dealerUserService.count(new LambdaQueryWrapper<DealerUser>().eq(DealerUser::getUserId,refereeId)) == 0) {
          return fail("邀请人ID不存在");
        }
        if (dealerApplyService.save(dealerApply)) {
            // 加入正式分销商
            dealerUser.setRealName(dealerApply.getRealName());
            dealerUser.setRefereeId(dealerApply.getRefereeId());
            dealerUserService.save(dealerUser);
            // 添加关系
          final DealerReferee referee = new DealerReferee();
          referee.setDealerId(refereeId);
          referee.setUserId(dealerUser.getUserId());
          referee.setLevel(1);
          referee.setTenantId(dealerApply.getTenantId());
          dealerRefereeService.save(referee);

            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分销商申请记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DealerApply dealerApply) {
        if (dealerApplyService.updateById(dealerApply)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分销商申请记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (dealerApplyService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分销商申请记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DealerApply> list) {
        if (dealerApplyService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分销商申请记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DealerApply> batchParam) {
        if (batchParam.update(dealerApplyService, "apply_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分销商申请记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (dealerApplyService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
